-- Create a user for executing monitoring utilities:

CREATE USER db_mon WITH PASSWORD 'somepass';

-- This function can return pg_stat_activity contents without
-- supeuser abilities.

CREATE OR REPLACE FUNCTION pg_stat_activity()
RETURNS SETOF pg_stat_activity
AS $$

SELECT * FROM pg_stat_activity;

$$ LANGUAGE sql SECURITY DEFINER;

REVOKE ALL ON FUNCTION pg_stat_activity()
  FROM PUBLIC;

GRANT EXECUTE ON pg_stat_activity() TO db_mon;

-- Create the pg_stat_statements extension.

CREATE EXTENSION pg_stat_statements;

-- This function can return pg_stat_statements contents without
-- supeuser abilities.

CREATE OR REPLACE FUNCTION pg_stat_statements()
RETURNS SETOF pg_stat_statements
AS $$

SELECT * FROM pg_stat_statements;

$$ LANGUAGE sql SECURITY DEFINER;

REVOKE ALL ON FUNCTION pg_stat_statements()
  FROM PUBLIC;

GRANT EXECUTE ON pg_stat_statements() TO db_mon;

-- Get the Process ID of the current backend:

SELECT pg_backend_pid() AS pid;

-- Cause some client activity for statistics:

SELECT * FROM information_schema.columns;

-- Long sample query to truncate strace output.

SELECT 'This is a very long query to view.';

