-- Query to create rep_user user:

CREATE USER rep_user WITH REPLICATION;

-- Change the rep_user user's password:

ALTER USER rep_user WITH PASSWORD 'newpass';

-- Confirm streaming replication is started:

SELECT client_addr, usename, state
  FROM pg_stat_replication;

-- Similar to above, but with sync_state and application_name.

SELECT client_addr, state, sync_state, application_name
  FROM pg_stat_replication;

-- Test synchronous replication

CREATE TABLE foo ( bar INT );

-- Use this to temporarily disable synchronous replication.

SET synchronous_commit TO false;

-- Get a list of pgbench tables on subscription system.

SELECT schemaname, tablename
  FROM pg_tables
 WHERE tablename LIKE 'pgbench%';

-- Confirm replication of pgbench_accounts on subscriber:

SELECT count(1)
  FROM pgbench_accounts;

